/*
 * treeview.js - Script for Treeview.
 *              v 1.0 2012/10/15 00:00:00 acompass.net
 * Copyright (C) 2012-2014 acompass.net
 * License: GPL v2 or (at your option) any later version
 */


(function() {

function toggle(event) {
  var element = event ? event.target : window.event.srcElement;

  if (element.nodeName == "LI") {
    var li = element;
    var ul = li.getElementsByTagName("UL")[0];

    tr.click( li.id, li.className );
    if (li.className == "expanded") {
      li.className = "collapsed";
      ul.style.display = "none";
    } else if (li.className == "collapsed") {
      if (ul) {
        li.className = "expanded";
        ul.style.display = "block";
      } else {
        return;
      }
    }
  }

}

var isMSIE = /*@cc_on!@*/false;

var tree   = document.getElementById("treeview");
if ( tree != null ) {
  tree.onclick     = toggle;
  if (isMSIE) {
    tree.ondblclick    = toggle;
  }
  tree = null;
}

var tree1   = document.getElementById("treeview1");
if ( tree1 != null ) {
  tree1.onclick     = toggle;
  if (isMSIE) {
    tree1.ondblclick    = toggle;
  }
  tree1 = null;
}

})();


var TreeRetain = function () {
  this.status = new Array();
  this.name = "treeview";

    if (!navigator.cookieEnabled) {
      alert("クッキーへの書き込みができません（メニュー再表示不能）");
      return;
    }

    this.status = load(this.name);
    if ( (this.status != undefined) && (this.status != "")
          && (this.status[0] !=undefined)){
      reflect( this.status );
    }
    else {
       // NOP;
    }

};

TreeRetain.prototype = {

  click : function( id, classNmae ) {
    if ( this.status == undefined ) {
      this.status = new Array();
    }
    retain( id, classNmae, this.status);
    save( this.status, this.name );
  }

};

var reflect = function( status ) {
  var treeArray = new Array('treeview', 'treeview1');
  for ( t = 0; t < treeArray.length; t++ ) {
    var tree   = document.getElementById(treeArray[t]);
    if ( tree == null ) {
      continue;
    }
    var lis = tree.getElementsByTagName("LI");
    for ( var i = 0; i < lis.length; i++ ) {
      if ( lis[i].id != "" ) {
        var indx = indexOf(status, lis[i].id);
        if ( indx != null ) {
          var ul = lis[i].getElementsByTagName("UL")[0];
          if ( ul != undefined ) {
            if ( status[indx].substr( status[indx].length -1, 1) == '-' ){
              lis[i].className = "expanded";
              ul.style.display = "block";
            }
            else {
              lis[i].className = "collapsed";
              ul.style.display = "none";
            }
          } else {
              alert("ul not found!");
          }
        }
      }
    }
  }
};

var retain = function( id, className, status ) {
  var sign;  // opposite of current sign.
  switch( className ) {
    case "collapsed" :
      sign = ":-";
      break;
    case "expanded" :
      sign = ":+";
      break;
    default :
      retrun;
  }

  var indx = indexOf( status, id);
  if ( indx == null ) {
    status[status.length] = id + sign;
  }
  else {
    status[indx] = id + sign;
  }
};

var load = function( name) {
    var status = new Array();
	var work = name + "=";
    var theCookie = document.cookie+";";
    var start = theCookie.indexOf(work);
    if (start != -1) {
      var end = theCookie.indexOf(";",start);
      var temp = unescape(theCookie.substring(start+work.length,end));
      status = temp.split(",");
      return status;
    }
    return;
};

var save = function( status, name ) {
    var theHour = 0.1;
    var setDay = new Date();
    setDay.setTime(setDay.getTime()+(theHour*1000*60*60));
    var expTime = setDay.toGMTString();
    var temp = status.toString();
    document.cookie = name + "=" + escape(temp) + ";expires=" + expTime;
};

var indexOf = function( ele, checkValue ) {
  for (var i=0; i < ele.length; i++ ) {
    if ( ele[i].substr( 0, ele[i].length-2) == checkValue ) {
      return i;
    }
  }
  return null;
};

var tr = new TreeRetain();
